import java.io.*;
import java.util.*;  //for class Vector

class ATM
{
   //start up a Checking and a Savings account, with starting balances
   static final double startingCheckingBalance=200;
   static final double startingSavingsBalance=1200;
   
   private static Checking checking = new Checking(2468,startingCheckingBalance);
   private static Savings savings = new Savings(2468,startingSavingsBalance);
   
   static DataInputStream input = new DataInputStream(System.in);
   
   static boolean verifyCard(Card card)  //verify PIN on card
   {
      int i=0; //give user 3 changes to get PIN right
      int PIN=0; //from user
      while (!card.validPin(PIN,checking) && i < 3)
      { System.out.print("Please enter 4-digit PIN:"); System.out.flush();
         try 
         {  
             String tempS = input.readLine();
             PIN = new Integer(tempS.trim()).intValue();
          }
          catch (Exception e)      
          { System.out.println("readLine fails"); 
             e.printStackTrace(); 
           }//catch
          i=i+1;  //user's next attempt to enter a PIN
          }//while
      if (i > 0) return card.validPin(PIN,checking); 
      else return false;
  }//verifyCard()
   
   static char chooseTransaction() //Deposit, Withdraw or Quit
   { char choice='?'; //from user
      while (choice != 'D' && choice != 'W' && choice != 'R' && choice != 'Q' )
      { System.out.print("Select Deposit, Withdraw, Review or Quit (d or w or r or q):"); 
         System.out.flush();
         try 
         { choice = (char) input.read(); //         Byte();   //read a single chararacter        
            input.readLine();                                 //consume \n
            choice = Character.toUpperCase(choice); //user can enter lower or upper case
         }
         catch (Exception e) {}
       } //while
       return choice; 
    } //chooseTransaction()

   static char chooseAccount()     //Checking or Savings
   { char choice='?'; //from user
      while (choice != 'C' && choice != 'S' && choice != 'Q')
      { System.out.print("Select Checking, Savings or Quit (c or s or q):");
         System.out.flush();         
         try 
         { choice = (char) input.readByte();   //read a single chararacter        
            input.readLine();                                 //consume \n
            choice = Character.toUpperCase(choice); //user can enter lower or upper case
         }
         catch (Exception e) {}
      }
     return choice;
   }

   static Transaction runTransaction(char transChoice,char accChoice)
   { 
      if (transChoice == 'D' && accChoice == 'C')
       { Deposit d = new Deposit(checking); return d; } //make Deposit to checking
      else if (transChoice == 'D' && accChoice == 'S')
       { Deposit d = new Deposit(savings); return d; } //make Deposit to savings
     else if (transChoice == 'W' && accChoice == 'C')
       { Withdrawal w = new Withdrawal(checking); return w; } //make Withdrawal from checking       
     //else if (transChoice == 'W' && accChoice == 'S')
     Withdrawal w = new Withdrawal(savings);  return w;       //make Deposit to checking
  }

  static void reviewTransactions(Vector currentTransactions)
  { 
     //First, display starting balances
     System.out.println("Starting balances:\n\tChecking: $" + startingCheckingBalance
                                           + " \n\tSavings: $" + startingSavingsBalance);
                                           
     //Display all the transactions run in this session.  (Note use of dynamic binding.)
      Enumeration actions = currentTransactions.elements();
     while (actions.hasMoreElements())
     {
        Transaction trans = (Transaction)actions.nextElement();        
         System.out.println(trans.toString());
     }
  }
  
   static void goodbye(Vector currentTransactions) throws IOException
   { //return card and say goobye   
     reviewTransactions(currentTransactions);
     System.out.println("Please take your ATM card now.");
     System.out.println("Thanks for using First Virtual Bank's ATM!");
     input.read();  //wait for input before exiting DOS window
   }

  public static void main(String args[])  throws Exception  
  {
     Vector currentTransactions = new Vector(1);  //track transactions here
     
     //First, simulate reading card and validing PIN
     Card ATMcard = new Card();
     ATMcard.askForCard(); 
            
     if (verifyCard(ATMcard)) //read and verify a card
     { char transChoice = chooseTransaction();     
        while (transChoice != 'Q')
        { if (transChoice == 'R')
              reviewTransactions(currentTransactions);
          else
          { char accChoice = chooseAccount();  //Checking or Savings?
             if (accChoice != 'Q') //run Deposit or Withdrawal & record in currentTransactions
                   currentTransactions.addElement(runTransaction(transChoice,accChoice));
           }//else
           transChoice = chooseTransaction();
         }//while
      }
      goodbye(currentTransactions);
   }
} //class ATM
