class Account
{
   int getPIN()      { return PIN; }      //extract PIN
   
   void setPIN(int pin)   throws ATMexception   //insert PIN
   { if (pin < 1000 || pin > 9999) //PIN must be 4 digits
          throw new ATMexception("PIN " + pin + " is not 4 digits");
      PIN = pin;
   }
 
   double getBalance()     { return balance; }  //extract balance
   
   void setBalance(double bal) throws ATMexception   //insert balance
   { if (bal < 0)		      //no negative balance
          throw new ATMexception("Cannot set negative balance: $" + bal);
      balance = bal;
   }

   double addToDeposits(double dep) //today's deposits
   { deposits = deposits + dep;
      return deposits;
   }
   
   double getDeposits()	 { return deposits; }   //extract deposits
  
   double subFromBalance(double withdraw)  throws ATMexception  
   { if (balance < withdraw)  
              throw new ATMexception("balance of $" + balance + " is less than requested withdrawal $" + withdraw);
      balance = balance - withdraw;
      return balance;
   }
   
   boolean sufficientBalance(double amount)
   //Enough in Account to cover subtraction of amount?
   { return (balance >= amount);  }

    //Constructor is protected; only call derived class constructors
    protected Account() //default constructor
    { deposits = 0; //today's balance start off zero
    }

    private  int PIN;                         //Personal Identification Number
    private double balance;        //not including today's deposits
    private double deposits;       //today's deposits
} //class Account

